; DTMF51
       
;lcd jednoradkovy se chova jako dvouradkovy, prvnich 8 zn z prvniho radku
;druhych 8 zn z druheho radku

; -------------------------- EQU pro hardware ---------------------------------

disp    equ     090h            ;Port 1 je 90h
RS      bit     P1.1            ;Instrukce/data displeje
RW      bit     P1.2            ;Read/write displeje
E       bit     P1.3            ;Enable displeje
ST      bit     P1.7            ;status displeje, tj. D7 jako status bit

Q1      bit     p3.4		;MT8870
Q2      bit     p3.3
Q3      bit     p3.2
Q4      bit     p3.1
std     bit     p3.0

zacni:  mov     0a8h,#00h        ;zablokovani vsech preruseni


;       Inicializace displeje v hlavnim programu:


; ------------------------------- Oziveni displeje ----------------------------
	clr     E               	;E dolu
	lcall   w200
	lcall   w200
	mov     disp,#00110000b 	;Prvni zapis
	call    d_ena                   
	lcall   w20
	mov     disp,#00110000b
	call    d_ena           	;odeslani dat
	lcall   w20
	mov     disp,#00110000b
	call    d_ena           	;odeslani dat
	mov     disp,#00100000b         ;4bitovy interface
	call    d_ena
	mov     r7,#00101000b           ;4Bit, 2radkovy, 5*7
	call    d_inst
	mov     r7,#00001000b           ;Display off
	call    d_inst
	mov     r7,#00001110b           ;Display on
	call    d_inst
	;mov     r7,#00001100b           ;Display on, cursor on, blink off
	mov     r7,#00000001b
	call    d_inst
	mov     r7,#00000110b           ;Entry mode increment, no shift
	call    d_inst
	call    d_clr                   ;Clear displeje
	mov     r7,#1d
	call    d_inst
	call    w20
	mov     r7,#2d
	call    d_inst
	call    w20
	mov     r7,#6d
	call    d_inst
	call    w20
	mov     r7,#12d
	call    d_inst
	call    w20
	mov     r7,#20d
	call    d_inst
	call    w20
	mov     r7,#40d
	call    d_inst
	call    w20
	mov     r7,#128d
	call    d_inst
	call    w20
	mov     r7,#'D'			;zobrazeni uvitaciho napisu
	call    d_data
	mov     r7,#'T'
	call    d_data
	mov     r7,#'M'
	call    d_data
	mov     r7,#'F'
	call    d_data
	mov     r7,#' '
	call    d_data
	mov     r7,#'5'
	call    d_data
	mov     r7,#'1'
	call    d_data
	mov     r7,#' '
	call    d_data
	
	call    w200
	mov     r7,#11000000b
	call    d_inst
	call    w20
	mov     r7,#' '
	call    d_data
	mov     r7,#' '
	call    d_data
	mov     r7,#' '
	call    d_data
	mov     r7,#' '
	call    d_data
	mov     r7,#' '
	call    d_data
	mov     r7,#' '
	call    d_data
	mov     r7,#' '
	call    d_data
	mov     r7,#' '
	call    d_data
	call    w200        
	call    w200
	call    w200

;************************** posun displeje **************

	mov     70h,#'-'	;pomocna pamet pro rotaci
	mov     71h,#'-'
	mov     72h,#'-'
	mov     73h,#'-'
	mov     74h,#'-'
	mov     75h,#'-'
	mov     76h,#'-'
	mov     77h,#'-'
	mov     78h,#'-'
	mov     79h,#'-'
	mov     7Ah,#'-'
	mov     7Bh,#'-'
	mov     7Ch,#'-'
	mov     7Dh,#'-'
	mov     7Eh,#'-'
	mov     7Fh,#'-'

dokola:					;hlavni nekonecna smycka
	
	;cekej na std log 1
	;pak je na data platny udaj
	;na konci cekej na std log 0
	;a zpet na zacatek

	jnb     std,$			;cekej na platna data
	call    w02
	;std je v jednicce
	;precti data

	mov     a,#0h
	mov     c,Q4			;prohozeni bitu (kvuli zjednoduseni PCB)
	rlc     a
	mov     c,Q3
	rlc     a
	mov     c,Q2
	rlc     a
	mov     c,Q1
	rlc     a        
					;osetreni znaku nevhodne ulozenych ve vztahu k ASCII
	cjne    a,#00001010b,neni1	;test na nulu
	mov     a,#0h
	jmp	neni
neni1:	cjne    a,#00001011b,neni2	;test na hvezdicku
	mov	a,#0FAh
	jmp 	neni
neni2:	cjne    a,#00001100b,neni	;test na krizek
	mov	a,#0F3h
neni:
	;v a je binarne kod, pricti 30h a zobraz
	add     a,#30h
	call    tisk
	 jb     std,$
	call    w02
	jmp     dokola

	ljmp    $

;********************************************************************************************
;PODPROGRAMY
;********************************************************************************************
;

;zpozdeni 200 ms
w200:   mov     r4,a
	push    00h
	push    01h
	mov     r1,#0ffh
loop2:  mov     r0,#0ffh
loop:   dec     r0
	mov     a,r0
	jnz     loop
	dec     r1
	mov     a,r1
	jnz     loop2
	mov     a,r4
	pop     01h
	pop     00h
	ret
;konec pauzy    
;
;pausa 20 ms
w20:    mov     r4,a
	push    00h
	push    01h
	mov     r1,#0ah
loop3:  mov     r0,#0ffh
loop1:  dec     r0
	mov     a,r0
	jnz     loop1
	dec     r1
	mov     a,r1
	jnz     loop3
	mov     a,r4
	pop     01h
	pop     00h
	ret
;
;
;pausa 02 ms
w02:    mov     r4,a
	push    00h
	push    01h
	mov     r1,#03d
loop4:  mov     r0,#0ffh
loop5:  dec     r0
	mov     a,r0
	jnz     loop5
	dec     r1
	mov     a,r1
	jnz     loop4
	mov     a,r4
	pop     01h
	pop     00h
	ret
;
;PROCEDURY PRO DISPLEJ
; ----------------------------- Pulz E na displej -----------------------------
d_ena:                  
	setb    E
	clr     E
	ret

; ----------------------- Cekani na ready stav displeje -----------------------
d_wait:                         ;cekani na bussy flag displeje
	push    psw
	mov     disp,#0f4h      ;nastaveni cteni a nahozeni bitu dat
wait_znovu:
	setb    E
	jnb     ST,dumy         ;uz to spadlo?
	clr     E               ;vynulovani E
	call    d_ena           ;dumy cyklus (4 bit)
	jmp     wait_znovu
dumy:
	clr     E
	call    d_ena           ;dumy cyklus (4 bit)
	pop     psw             ;muzeme dal
	ret 

; ------------------------ Vyslani dat na displej -----------------------------
;       Data nebo instrukce se daji do R7 a zavola se tahle rutinka

; ----- Instrukce -----
d_inst:         
	push    acc
	push    psw
	clr     c               ;jedna se o instrukci
	jmp     d_send          ;vlastni zapisy na displej

; ----- Data -----
d_data:
	push    acc
	push    psw
	setb    c

; ----- Vlastni zapis -----     
d_send:
	call    d_wait
	mov     a,#11110000b    ;priprava masky
	anl     a,r7            ;prevzeti a vymaskovani instrukce z R7
	mov     disp,a          ;vystaveni dat
	mov     RS,c     
	call    d_ena           ;zapis pulzem na E
	mov     a,#00001111b    ;priprava masky
	anl     a,r7            ;prevzeti a vymaskovani instrukce z R7
	swap    a               ;prehozeni niblu
	mov     disp,a          ;vystaveni dat
	mov     RS,c
	call    d_ena           ;zapis pulzem na E
	pop     psw
	pop     acc
	ret

; ----------------------------- Cursor home -----------------------------------
d_home: mov r7,#00000010b          
	jmp d_inst
	    
; ---------------------------- Display clear ----------------------------------
d_clr:
	mov r7,#00000001b              ;Clear Home
	jmp d_inst

;-------------------- tisk vsech sestanacti ----------------
; do acc dej znak tisknuty na posledni pozici

tisk:
	;posunout vlevo, rotace stavajiciho obsahu
	mov     70h,71h
	mov     71h,72h        
	mov     72h,73h
	mov     73h,74h        
	mov     74h,75h
	mov     75h,76h        
	mov     76h,77h
	mov     77h,78h        
	mov     78h,79h
	mov     79h,7Ah        
	mov     7Ah,7Bh
	mov     7Bh,7Ch        
	mov     7Ch,7Dh
	mov     7Dh,7Eh        
	mov     7Eh,7Fh
	
	
	;
	;a zde zadani posledniho znaku
	mov     7Fh,a

	;a ted zobrazit znak po znaku na LCD
	;sestnact pozic
	mov     r7,#10000000b           ;zadani pozice znaku 00h
	call    d_inst
	mov     r7,70h
	call    d_data
	mov     r7,#10000001b           ;zadani pozice znaku 00h
	call    d_inst
	mov     r7,71h
	call    d_data
	mov     r7,#10000010b           ;zadani pozice znaku 00h
	call    d_inst
	mov     r7,72h
	call    d_data
	mov     r7,#10000011b           ;zadani pozice znaku 00h
	call    d_inst
	mov     r7,73h
	call    d_data
	mov     r7,#10000100b           ;zadani pozice znaku 00h
	call    d_inst
	mov     r7,74h
	call    d_data
	mov     r7,#10000101b           ;zadani pozice znaku 00h
	call    d_inst
	mov     r7,75h
	call    d_data
	mov     r7,#10000110b           ;zadani pozice znaku 00h
	call    d_inst
	mov     r7,76h
	call    d_data
	mov     r7,#10000111b           ;zadani pozice znaku 00h
	call    d_inst
	mov     r7,77h
	call    d_data
	mov     r7,#11000000b           ;zadani pozice znaku 40h
	call    d_inst
	mov     r7,78h
	call    d_data
	mov     r7,#11000001b           ;zadani pozice znaku 00h
	call    d_inst
	mov     r7,79h
	call    d_data
	mov     r7,#11000010b           ;zadani pozice znaku 00h
	call    d_inst
	mov     r7,7Ah
	call    d_data
	mov     r7,#11000011b           ;zadani pozice znaku 00h
	call    d_inst
	mov     r7,7Bh
	call    d_data
	mov     r7,#11000100b           ;zadani pozice znaku 00h
	call    d_inst
	mov     r7,7Ch
	call    d_data
	mov     r7,#11000101b           ;zadani pozice znaku 00h
	call    d_inst
	mov     r7,7Dh
	call    d_data
	mov     r7,#11000110b           ;zadani pozice znaku 00h
	call    d_inst
	mov     r7,7Eh
	call    d_data
	mov     r7,#11000111b           ;zadani pozice znaku 00h
	call    d_inst
	mov     r7,7Fh
	call    d_data
	ret


	end
